<div id="fl-welcome-form" class="fl-settings-form">

	<h3 class="fl-settings-form-header"><?php _e('Welcome to Beaver Builder!', 'fl-builder'); ?></h3>

	<div class="fl-settings-form-content fl-welcome-page-content">

		<p><?php _e('Thank you for choosing Beaver Builder and welcome to the colony! Find some helpful information below. Also, to the left are the Page Builder settings options.', 'fl-builder'); ?></p>

		<h4><?php _e('Getting Started - Building your first page.', 'fl-builder'); ?></h4>

		<div class="fl-welcome-col-wrap">

			<div class="fl-welcome-col">

				<p><a href="<?php echo admin_url(); ?>post-new.php?post_type=page" class="fl-welcome-big-link"><?php _e('Pages → Add New', 'fl-builder'); ?></a></p>

				<p><?php _e('Ready to start building? Add a new page and jump into Beaver Builder by clicking the Page Builder tab shown on the image.', 'fl-builder'); ?></p>

				<h4><?php _e('Join the Community', 'fl-builder'); ?></h4>

				<p><?php _e('There\'s a wonderful community of "Beaver Builders" out there and we\'d love it if <em>you</em> joined us!', 'fl-builder'); ?></p>

				<ul>
					<li><?php _e('<a href="https://www.facebook.com/groups/beaverbuilders/" target="_blank">Join the Beaver Builder\'s Group on Facebook</a>', 'fl-builder'); ?></li>
					<li><?php _e('<a href="https://beaverbuilders.herokuapp.com/" target="_blank">Join the Beaver Builder\'s Group on Slack</a>', 'fl-builder'); ?></li>
				</ul>

				<p><?php _e('Come by and share a project, ask a question, or just say hi! For news about new features and updates, like our <a href="https://www.facebook.com/wpbeaverbuilder/" target="_blank">Facebook Page</a> or follow us <a href="https://twitter.com/beaverbuilder" target="_blank">on Twitter</a>.', 'fl-builder'); ?></p>

			</div>

			<div class="fl-welcome-col">
				<img class="fl-welcome-img" src="<?php echo FL_BUILDER_URL; ?>img/screenshot-getting-started.jpg" alt="">
			</div>

		</div>

		<hr>

		<div class="fl-welcome-col-wrap">

			<div class="fl-welcome-col">

				<h4><?php _e('What\'s New in Beaver Builder 1.7', 'fl-builder'); ?></h4>

				<p><?php _e('Beaver Builder 1.7 is live and it\'s got some slick new features:', 'fl-builder'); ?></p>

				<ul>
					<li><?php _e('Partial Refresh is live and will make your builder experience faster and more fluid.', 'fl-builder'); ?></li>
					<li><?php _e('The Audio Module and Count Down module are available!', 'fl-builder'); ?></li>
					<li><?php _e('You can now insert layouts with a shortcode.', 'fl-builder'); ?></li>
				</ul>

				<p><?php _e('Read more our <a href="https://www.wpbeaverbuilder.com/beaver-builder-1-7-now-with-partial-refresh-per-page-code-settings-and-our-first-shortcode/" target="_blank">update post</a> or <a href="https://www.wpbeaverbuilder.com/change-logs/" target="_blank">change logs</a>.', 'fl-builder'); ?></p>

			</div>

			<div class="fl-welcome-col">

				<h4><?php _e('Need Some Help?', 'fl-builder');  ?></h4>

				<p><?php _e('We take pride in offering outstanding support.', 'fl-builder');  ?></p>

				<p><?php _e('The fastest way to find an answer to a question is to see if someone\'s already answered it!', 'fl-builder');  ?></p>

				<p><?php _e('For that, check our <a href="https://www.wpbeaverbuilder.com/knowledge-base/" target="_blank">Knowledge Base</a>, <a href="https://www.wpbeaverbuilder.com/frequently-asked-questions/" target="_blank">FAQ page</a>, or search our <a href="http://www.wpbeaverbuilder.com/support/" target="_blank">support forum.</a>', 'fl-builder');  ?></p>

				<p><?php _e('If you can\'t find an answer, feel free to post a question in our <a href="http://www.wpbeaverbuilder.com/support/" target="_blank">support forum</a>.', 'fl-builder'); ?></p>
			</div>

		</div>

	</div>
</div>
