<?php
/*
 * Plugin Name: Layers Pro
 * Version: 1.2
 * Plugin URI: http://www.oboxthemes.com
 * Description: Unlock customizability in the Layers framework.
 * Author: Obox
 * Author URI: http://www.oboxthemes.com/
 * Requires at least: 4.0
 * Tested up to: 4.1
 * Layers Plugin: True
 * Layers Required Version: 1.2.8
 *
 * Text Domain: layers-pro
 * Domain Path: /lang/
 *
 * @package WordPress
 * @author Obox
 * @since 1.0.0
 */

if ( ! defined( 'ABSPATH' ) ) exit;

if ( defined( 'SCRIPT_DEBUG' ) && TRUE == SCRIPT_DEBUG ) {
    define( 'LAYERS_PRO_VER', rand( 0 , 100 ) );
} else {
    define( 'LAYERS_PRO_VER', '1.2' );
}

define( 'LAYERS_PRO_SLUG' , 'layers-pro' );
define( 'LAYERS_PRO_REQUIRED_VERSION' , '1.2.8' );
define( 'LAYERS_PRO_DIR' , plugin_dir_path( __FILE__ ) );
define( 'LAYERS_PRO_URI' , plugin_dir_url( __FILE__ ) );
define( 'LAYERS_PRO_FILE' , __FILE__ );

// Load plugin class files
require_once( 'includes/class-layers-pro.php' );

register_activation_hook( LAYERS_PRO_FILE , array( 'Layers_Pro', 'activate' ) );

if( !function_exists( 'layers_pro_init' ) ) {
    // Instantiate Plugin
    function layers_pro_init() {

        // return; // Temp Disable

        global $layers_pro;

        $layers_pro = Layers_Pro::get_instance();

        // Localization
        load_plugin_textdomain( LAYERS_PRO_SLUG, FALSE, dirname( plugin_basename( __FILE__ ) ) . "/lang/" );
    }
    add_action( 'plugins_loaded', 'layers_pro_init' );
}
