<?php  /**
 * Layers Theme Filters & Hooks
 *
 * This file is used to modify any Layers HTML and or CSS classes.
 *
 * @package Layers
 * @since Layers 1.0
 */


/**
* Register WooCommerce Widgets
*/
if (!function_exists('layers_woocommerce_cart_button')) {
		function layers_woocommerce_cart_button(){
				global $woocommerce;

				if( !$woocommerce ) return;

				if( !layers_get_theme_mod( 'woocommerce-show-site-cart-heading') ) return;

				if( !layers_get_theme_mod( 'woocommerce-show-menu-cart-icon' ) && !layers_get_theme_mod( 'woocommerce-show-menu-cart-amount' ) && !layers_get_theme_mod( 'woocommerce-show-menu-cart-products' ) ) return; ?>
				<div class="header-cart" data-toggle="#off-canvas-right" data-toggle-class="open">
					<a href="<?php echo $woocommerce->cart->get_cart_url(); ?>" class="cart">
						<?php if( layers_get_theme_mod( 'woocommerce-show-menu-cart-icon' ) ) { ?>
							<span class="l-shopping-cart"></span>
						<?php } ?>
						<?php if( layers_get_theme_mod( 'woocommerce-show-menu-cart-products' ) ) { ?>
							<span class="cart-count"><?php echo $woocommerce->cart->cart_contents_count; ?></span>
						<?php } ?>
						<?php if( layers_get_theme_mod( 'woocommerce-show-menu-cart-amount' ) ) { ?>
							<span class="cart-total">
								<?php echo $woocommerce->cart->get_cart_subtotal(); ?>
							</span>
						<?php } ?>
					</a>
				</div>
		<?php };
}

add_action( 'layers_before_header_nav' , 'layers_woocommerce_cart_button' , 30 );


if (!function_exists('layers_woocommerce_cart_fragments')) {
		function layers_woocommerce_cart_fragments( $fragments ){
			 ob_start();

			layers_woocommerce_cart_button();

			$fragments[ 'div.header-cart' ] = ob_get_clean();

			return $fragments;
		}
		// @TODO add_filter('add_to_cart_fragments', 'layers_woocommerce_cart_fragments');
}