<?php
/**
* Customizer Defaults
*
* The following filter is used to setup the customizer defaults which are setup by your child theme
*
*/
function layers_acquire_customizer_defaults( $defaults ){

    $defaults = array(
      'header-background-color' => FALSE,
      'site-accent-color' => '#3499d1',
      'footer-background-color' => '#333333',
      'body-fonts' => 'Lato',
      'heading-fonts' => 'Merriweather',
      'header-width' => 'layout-boxed',
      'header-menu-layout' => 'header-logo-left',
      'footer-copyright-text' => 'Copyright 2016 Your Company. Powered by Home Inspector Pro.',
      'show-layers-badge' => FALSE,
    );

    return $defaults;
}
add_filter( 'layers_customizer_control_defaults', 'layers_acquire_customizer_defaults' );

/**
*
* Smooth scroll jQuery
*
*/

if( ! function_exists( 'layers_acquire_child_scripts' ) ) {
        
    function layers_acquire_child_scripts() {
        
        wp_enqueue_script(
            'layers-child' . '-custom',
            get_stylesheet_directory_uri() . '/assets/js/theme.js',
            array(
                'jquery', // make sure this only loads if jQuery has loaded
            )
        ); // Custom Child Theme jQuery  
        
    }
  
}

add_action('wp_enqueue_scripts', 'layers_acquire_child_scripts');

/**
* Preset Layouts
*
* The following filter adds your Layers pages to the preset layouts under Layers > Add Page
*
*/
function layers_acquire_presets( $layers_preset_layouts ){

        $layers_acquire_presets[ 'layers_acquire_-home' ] = array(
            'title' => __( 'Home', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/home.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-455":{"layers-widget-slide-3":{"slide_height":"550","show_slider_arrows":"on","slider_arrow_color":"","animation_type":"parallax","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"547,152,549","slides":{"547":{"design":{"background":{"image":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2013\/08\/jpeg-1.jpeg","color":"#444","repeat":"no-repeat","position":"center","stretch":"on","darken":"on"},"featuredimage":"","featuredvideo":"","imagealign":"image-right","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Great for Businesses","excerpt":"<p>Acquire is a feature rich Obox theme which allows you to create sites from scratch to showcase your business.<\/p>","link":"services\/","link_text":"Find Out More"},"152":{"design":{"background":{"image":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/workbackground.jpg","color":"#444","repeat":"no-repeat","position":"center","stretch":"on","darken":"on"},"featuredimage":"","featuredvideo":"","imagealign":"image-bottom","fonts":{"align":"text-center","size":"large","color":""},"advanced":{"customclass":""}},"title":" WordPress Business Theme","excerpt":"<p>Finally a business theme that is packed with features that are easy to use and understand with no steep learning curve required.<\/p>","link":"","link_text":""},"549":{"design":{"background":{"image":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/mobile-background.jpg","color":"#444","repeat":"no-repeat","position":"center","stretch":"on","darken":"on"},"featuredimage":"","featuredvideo":"","imagealign":"image-left","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Responsive","excerpt":"<p>By using a mobile-friendly theme you know  that any visitor to your website will be having the best experience no  matter what device it is they\u2019re using.<\/p>","link":"","link_text":""}}},"layers-widget-column-3":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"470,404,188","columns":{"470":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/icon-mergers.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Mergers & Acquisitions","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"404":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/icon-assets.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Asset Management ","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"188":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/icon-diversify.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Diversification","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""}}},"layers-widget-slide-5":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"parallax","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"1","slide_ids":"615,592","slides":{"615":{"design":{"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"title":"\u201cGood stuff here. Does exactly what it says it does without major fluff in the code. One of the best themes for a great framework that I\'ve ever used.\u201d","excerpt":"<p>~\u00a0Jay Denim<\/p>","link":"","link_text":"See More"},"592":{"design":{"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"title":"\u201cEvery visible endeavour has been made to make this an amazingly simple product to use.\u201d","excerpt":"<p>~\u00a0Leo Gopal<\/p>","link":"","link_text":"See More"}}},"layers-widget-column-5":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-center","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"Our team is backed by over thirty years of experience.","excerpt":"","column_ids":"328,702,422,525","columns":{"328":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-05.jpg","featuredvideo":"","imageratios":"image-round","imagealign":"image-top","fonts":{"align":"text-center","size":"small","color":""},"advanced":{"customclass":""}},"width":"3","title":"Dan Preston","excerpt":"<p>Founder &\u00a0CEO<\/p>","link":"","link_text":""},"702":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-07.jpg","featuredvideo":"","imageratios":"image-round","imagealign":"image-top","fonts":{"align":"text-center","size":"small","color":""},"advanced":{"customclass":""}},"width":"3","title":"Kevin Preston","excerpt":"<p>Mergers & Acquisitions<\/p>","link":"","link_text":""},"422":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-10.jpg","featuredvideo":"","imageratios":"image-round","imagealign":"image-top","fonts":{"align":"text-center","size":"small","color":""},"advanced":{"customclass":""}},"width":"3","title":"Daniella Pernel","excerpt":"<p>Financial Services<\/p>","link":"","link_text":""},"525":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-02.jpg","featuredvideo":"","imageratios":"image-round","imagealign":"image-top","fonts":{"align":"text-center","size":"small","color":""},"advanced":{"customclass":""}},"width":"3","title":"Lance Tekkan","excerpt":"<p>Client Relations<\/p>","link":"","link_text":""}}},"layers-widget-slide-6":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"site-wide-cta-banner","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"698","slides":{"698":{"design":{"background":{"image":"","color":"#3499d1","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"title":"A site wide call to action bar!","excerpt":"","link":"#","link_text":"Find Out More"}}},"layers-widget-post-3":{"design":{"layout":"layout-boxed","fonts":{"align":"text-left","size":"medium","color":""},"columns":"3","column-background-color":"","gutter":"on","buttons":{"buttons-size":"medium","background-color":""},"liststyle":"list-grid","imageratios":"image-square","background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"text_style":"regular","show_media":"on","show_titles":"on","show_excerpts":"on","excerpt_length":"200","show_dates":"on","show_call_to_action":"on","call_to_action":"Read More","title":"Latest News","excerpt":"","category":"0","posts_per_page":"3","order":"{\"orderby\":\"date\",\"order\":\"desc\"}"}}}'
        );
        $layers_acquire_presets[ 'layers_acquire_-services' ] = array(
            'title' => __( 'Services', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/services.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-487":{"layers-widget-slide-8":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"718","slides":{"718":{"design":{"background":{"image":"","color":"#3499d1","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Services","excerpt":"","link":"","link_text":""}}},"layers-widget-column-7":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"540,962,788,11,732,315","columns":{"540":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/offshore.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Offshore management","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"962":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/unit-trusts.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Unit trust investments","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"788":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/retirement.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Retirement programs","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"11":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/personal.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Personalised service from experienced professionals","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"732":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/global.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Network of helpful qualified global investors","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""},"315":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/discreet.png","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Efficient and discreet: we value your time and privacy","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae massa velit, eu laoreet massa. Sed ac orci libero.<\/p>","link":"","link_text":""}}},"layers-widget-slide-9":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"100","right":"","bottom":"100","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"718","slides":{"718":{"design":{"background":{"image":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/happy-customers-bg.jpg","color":"#000000","repeat":"no-repeat","position":"center","stretch":"on","darken":"on"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-center","size":"medium","color":""},"advanced":{"customclass":""}},"title":"\u201cEvery visible endeavour has been made to make this an amazingly simple product to use.\u201d","excerpt":"~ Leo Gopal","link":"","link_text":"See More"}}}}}'
        );
        $layers_acquire_presets[ 'layers_acquire_-team' ] = array(
            'title' => __( 'Team', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/team.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-500":{"layers-widget-slide-11":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"588","slides":{"588":{"design":{"background":{"image":"","color":"#3499d1","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Our Team","excerpt":"","link":"","link_text":"See More"}}},"layers-widget-column-10":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"Our Directors","excerpt":"<p>Lorem ipsum\u00a0mattis ultricies convallis. Sed cursus ornare risus, et mollis tortor consectetur at. Pellentesque elit justo\u00a0pellentesque.<\/p>","column_ids":"414,437","columns":{"414":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-05.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"6","title":"Director Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"437":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-07.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"6","title":"Director Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""}}},"layers-widget-column-9":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"Our Incredible Team","excerpt":"","column_ids":"414,954,454,838,154,3","columns":{"414":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-10.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"954":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-07.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"454":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-05.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"838":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-02.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"154":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-08.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""},"3":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/team-04.jpg","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Member Name","excerpt":"<p>Give us a brief description of the person that you are promoting. Try keep it short so that it is easy for people to scan your page.<\/p>","link":"","link_text":""}}}}}'
        );
        $layers_acquire_presets[ 'layers_acquire_-contact' ] = array(
            'title' => __( 'Contact', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/contact.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-509":{"layers-widget-slide-13":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"317","slides":{"317":{"design":{"background":{"image":"","color":"#3499d1","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Contact Us","excerpt":"","link":"","link_text":"See More"}}},"layers-widget-map-3":{"design":{"layout":"layout-fullwidth","fonts":{"align":"text-center","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"show_google_map":"on","map_height":"400","google_maps_zoom":"14","title":"","excerpt":"","google_maps_location":"Green Point, South Africa","google_maps_long_lat":"","address_shown":"","contact_form":""},"layers-widget-column-12":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"187,941","columns":{"187":{"design":{"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"8","title":"Mail Us","excerpt":"<p>[contact-form-7 id=\"510\" title=\"Contact form 1\"]<\/p>","link":"","link_text":""},"941":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Business Address","excerpt":"<p>Green Point<br>Cape Town<br>South Africa<br>+27\u00a023\u00a0456\u00a06543<\/p>","link":"","link_text":""}}}}}'
        );
        $layers_acquire_presets[ 'layers_acquire_-about' ] = array(
            'title' => __( 'About', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/about.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-518":{"layers-widget-slide-15":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"1","slide_ids":"476","slides":{"476":{"design":{"background":{"image":"","color":"#3499d1","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"About Us","excerpt":"","link":"","link_text":"See More"}}},"layers-widget-column-15":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"40","right":"","bottom":"20","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"634,62,867","columns":{"634":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Our Values","excerpt":"Give us a brief description of the service that you are promoting. Try keep it short so that it is easy for people to scan your page.","link":"","link_text":""},"62":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"Our Mission","excerpt":"Give us a brief description of the service that you are promoting. Try keep it short so that it is easy for people to scan your page.","link":"","link_text":""},"867":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"4","title":"How We Do It","excerpt":"Give us a brief description of the service that you are promoting. Try keep it short so that it is easy for people to scan your page.","link":"","link_text":""}}},"layers-widget-column-14":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"auto-center","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"308,502,867","columns":{"308":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/happy-business.jpg","featuredvideo":"","imagealign":"image-left","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"width":"12","title":"We live and breathe finance","excerpt":"<p>Curabitur blandit elementum consequat. Quisque id magna nulla. Maecenas volutpat varius orci. Curabitur non diam nec nulla.<\/p><ul><li>In efficitur dictum<\/li><li>Enim vel congue<\/li><li>Maecenas eget libero<\/li><\/ul>","link":"services\/","link_text":"View our Services"},"502":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/happy-time.jpg","featuredvideo":"","imagealign":"image-right","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"width":"12","title":"We value your time","excerpt":"<p>Curabitur blandit elementum consequat. Quisque id magna nulla. Maecenas volutpat varius orci. Curabitur non diam nec nulla.<\/p><ul><li>In efficitur dictum<\/li><li>Enim vel congue<\/li><li>Maecenas eget libero<\/li><\/ul>","link":"services\/","link_text":"View our Services"},"867":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/happy-team.jpg","featuredvideo":"","imagealign":"image-left","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"width":"12","title":"We value team work","excerpt":"<p>Curabitur blandit elementum consequat. Quisque id magna nulla. Maecenas volutpat varius orci. Curabitur non diam nec nulla.<\/p><ul><li>In efficitur dictum<\/li><li>Enim vel congue<\/li><li>Maecenas eget libero<\/li><\/ul><p>Molestie lacus et, dictum nunc. Mauris nisi eros, commodo eu elementum ac, sodales id ante. Suspendisse sit amet dignissim augue<\/p>","link":"team\/","link_text":"Meet the team"}}}}}'
        );
        $layers_acquire_presets[ 'layers_acquire_-careers' ] = array(
            'title' => __( 'Careers', 'layers-acquire' ),
            'screenshot' => get_stylesheet_directory_uri().'/assets/preset-screenshots/careers.jpg',
            'screenshot_type' => 'png',
            'json' =>  '{"obox-layers-builder-524":{"layers-widget-slide-17":{"autoheight_slides":"on","slide_height":"550","slider_arrow_color":"","animation_type":"slide","slide_time":"","design":{"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"focus_slide":"0","slide_ids":"765","slides":{"765":{"design":{"background":{"image":"http:\/\/obox.beta\/acquire\/wp-content\/uploads\/sites\/25\/2015\/11\/happy-customers-bg.jpg","color":"#444","repeat":"no-repeat","position":"center","stretch":"on"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"large","color":""},"advanced":{"customclass":""}},"title":"Careers","excerpt":"","link":"","link_text":"See More"}}},"layers-widget-column-17":{"design":{"layout":"layout-boxed","liststyle":"list-grid","gutter":"on","fonts":{"align":"text-left","size":"medium","color":""},"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"advanced":{"customclass":"","customcss":"","padding":{"top":"","right":"","bottom":"","left":""},"margin":{"top":"","right":"","bottom":"","left":""},"anchor":""}},"title":"","excerpt":"","column_ids":"20,486","columns":{"20":{"design":{"background":{"image":"","color":"","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"7","title":"Senior Finance Manager","excerpt":"<p>Lorem ipsum dolor sit amet, consectetur  adipisicing elit. Nemo, natus voluptatibus adipisci porro magni dolore  eos eius ducimus corporis quos perspiciatis quis iste, vitae autem  libero ullam omnis cupiditate quam.<\/p><p><strong>Basic Requirements<\/strong><\/p><ul><li>Magni dolore eos<\/li><li>Vitae\u00a0autem\u00a0libero<\/li><li>Ullam\u00a0omnis\u00a0cupiditate<\/li><li>Nemo\u00a0natus voluptatibus adipisci<\/li><\/ul><p><strong>Expectations<\/strong><\/p><p>Aenean  id ipsum ante. Mauris ac pulvinar nulla, pellentesque condimentum  velit. Donec sed orci justo. Vivamus laoreet ultricies felis, sit amet  tincidunt lacus interdum ac. Sed nec ipsum et quam iaculis varius a a  ligula.<br><\/p><ul><li>Magni dolore eos<\/li><li>Vitae\u00a0autem\u00a0libero<\/li><li>Ullam\u00a0omnis\u00a0cupiditate<\/li><li>Nemo\u00a0natus\u00a0voluptatibus\u00a0adipisci<\/li><\/ul><p>Maecenas  ante metus, molestie in rhoncus et, vehicula quis massa. Phasellus  blandit libero at fermentum sollicitudin. Maecenas venenatis eleifend  ligula sed lacinia.<\/p>","link":"","link_text":""},"486":{"design":{"background":{"image":"","color":"#f1f5f7","repeat":"no-repeat","position":"center"},"featuredimage":"","featuredvideo":"","imagealign":"image-top","fonts":{"align":"text-left","size":"medium","color":""},"advanced":{"customclass":""}},"width":"5","title":"Apply Now","excerpt":"<p>[contact-form-7 id=\"525\" title=\"Job Application\"]\u00a0\u00a0\u00a0\u00a0<\/p>","link":"","link_text":""}}}}}'
        );

    return array_merge( $layers_acquire_presets,  $layers_preset_layouts );
}

add_filter( 'layers_preset_layouts', 'layers_acquire_presets', 0 );